<?php
if (!defined('ABSPATH')) exit;

class WSKO_Controller_Iframe extends WSKO_Controller
{
	public $is_invisible_page = true;
	public $has_main_nav_link = false;
	public $link = "iframe";
	
	public $template_folder = "iframe";
	
	public function get_title()
	{
		return __('Iframe', 'wsko');
	}
	
	public function custom_view()
	{
        if (WSKO_Class_Helper::check_user_permissions(false))
        {
            $type = isset($_GET['type']) ? sanitize_text_field($_GET['type']) : false;
            $arg = isset($_GET['arg']) ? sanitize_text_field($_GET['arg']) : false;
            switch ($type)
            {
                case 'co':
                $arg = intval($arg);
                if ($arg)
                {
                    ob_start();
                    ?><script type="text/javascript">document.documentElement.classList.add('wsko-co-iframe')</script>
					<style>#adminmenumain{display:none;!important}html,body,#wpcontent{margin:0px!important;padding:0px!important;}html,body,#wpwrap{background-color:white!important;}</style><?php
                    $widget = isset($_GET['widget']) && $_GET['widget'] && $_GET['widget'] != 'false' ? true: false;
                    return ob_get_clean().WSKO_Controller_Optimizer::render($arg, $widget, false, false, true);
                }
                break;
                case 'tax_meta':
                $taxonomy = isset($_GET['taxonomy']) ? sanitize_text_field($_GET['taxonomy']) : false;
                $term_id = intval($arg);
                if ($term_id && $taxonomy)
                {
                    ob_start();
                    ?><script type="text/javascript">document.documentElement.classList.add('wsko-co-iframe')</script>
					<style>#adminmenumain{display:none;!important}html,body,#wpcontent{margin:0px!important;padding:0px!important;}html,body,#wpwrap{background-color:#f1f1f1!important;}</style><?php
                    return ob_get_clean().WSKO_Class_Template::render_template('tools/template-metas-view-tax.php', array('term_key' => $taxonomy.':'.$term_id), true);
                }
                break;
            }
            WSKO_Class_Template::render_notification('error', array('msg' => wsko_loc('notif', 'iframe_incomplete')));
        }
        else
        {
            WSKO_Class_Template::render_notification('error', array('msg' => wsko_loc('notif', 'no_permission')));
        }
        return false;
	}
	
	public static function load_lazy_page_data()
	{
		return true;
    }
    
    public static function get_iframe($type, $arg = false, $params = array())
    {
        $width = isset($params['width']) ? $params['width'] : 500;
        $height = isset($params['height']) ? $params['height'] : 300;
        $url_data = isset($params['url_data']) ? $params['url_data'] : array();
        $src = WSKO_Controller_Iframe::get_link().'&'.http_build_query(array('type' => $type, 'arg' => $arg) + (is_array($url_data)?$url_data:array()));
        return '<iframe src="'.$src.'" width="'.$width.'" height="'.$height.'"></iframe>';
    }

    public function render_head_scripts()
    {
        //inherit empty header
    }
	
	//Singleton
	static $instance;
}
WSKO_Controller_Iframe::init_controller();
?>